`orthant.miwa` <-
  function(mu, Sigma, istart=1, conesonly=F, log2G=8) {
    stopifnot(log2G<=12)
    n = length(mu)
    if(n==1)
      return(list(value=pnorm(0, -mu, sqrt(Sigma)), cones=1))
    if(istart>1) {
      ind = c(istart, (1:n)[-istart])
      Sigma = Sigma[ind,ind]
      mu = mu[ind]
    }
    sd = sqrt(diag(Sigma))
    Rho = Sigma/outer(sd,sd)
    mu = mu/sd
    result = .C("orthant_miwa_R", as.integer(n), as.double(mu), 
        as.double(Rho), as.integer(log2G), value = double(1), 
        cones = integer(1), as.integer(conesonly), PACKAGE = "orthants")
    if (!is.na(result$value))
      if (result$value<0)
        result$value = 0
    return(result[c("value", "cones")])
}
