#include <complex.h>

#ifdef USING_FFTW3
# include <fftw3.h>
#endif

/* Represent a complex-valued function on a real grid */
typedef struct {
  double start, delta; 
  int nmax, n;   /* nmax is available slots in vals, n is slots used */
#ifdef USING_FFTW3
  fftw_complex *vals;
#else
  complex *vals;
#endif
} funcapprox;

/* Represent a real-valued function on a real grid */
typedef struct {
  double start, delta; 
  int nmax, n;   /* nmax is available slots in vals, n is slots used */
  double *vals;
} Rfuncapprox;

/* 
If this is ever changed, need to change name of cft to cft2 (or some
similar versioning approach) so as to prevent incompatible versions of
orthant and fftplus trying to work together.
*/

typedef funcapprox(cftfunction_t)(funcapprox, 
				   double,  double, 
				   int, int, int);

extern cftfunction_t cft;

#ifdef FOR_R
extern void cft_R(Rcomplex *x, int *np, double *startp, double *deltap, 
	   double *ostartp, double *odeltap, int *onratiop, 
	   int *invertp,
	   int *filon3p,
	   Rcomplex *xout
	   );
#endif
