void symmchol(const int n,  double S[n][n], double U[n][n]);

void upperinvT(const int n, double U[n][n], double L[n][n]);

void lowermulv(const int n,  double L[n][n], const double V[n], 
	       double Vout[n]);

static inline void vcopy(const int n; 
			 double to[n], 
			 const int n, 
			 const double from[n]) {
  int i;
  for(i=0; i<n; i++) to[i] = from[i];
}

static inline void vcopym(const int n;
			  double to[n], 
			  const int n, 
			  const double from[n],
			  const double mul) {
  int i;
  for(i=0; i<n; i++) to[i] = mul*from[i];
}

static inline void vaddm(const int n;
			 double to[n], 
			 const int n, 
			 const double from[n],
			 const double mul) {
  int i;
  for(i=0; i<n; i++) to[i] += mul*from[i];
}

static inline void vsub(const int n;
			double to[n], 
			const int n, 
			const double from[n]) {
  int i;
  for(i=0; i<n; i++) to[i] -= from[i];
}

static inline void vscale(const int n;
			  double x[n],
			  const int n,
			  double mul) {
  int i;
  for(i=0; i<n; i++) x[i] *= mul;
}

static inline double vdot(const int n, 
			  const double x[n], 
			  const double y[n]) {
  int i;
  double dot=0;
  for(i=0; i<n; i++) dot += x[i]*y[i];
  return dot;
}

static inline double vnorm2(const int n, 
			    const double x[n]) {
  int i;
  double norm2=0;
  for(i=0; i<n; i++) norm2 += x[i]*x[i];
  return norm2;
}

