#ifdef FOR_R
# include <R.h>
# include <Rinternals.h>
# include <R_ext/Rdynload.h>
# include "cft.h"

extern cftfunction_t *cftp;

static R_NativePrimitiveArgType orthant_miwa_R_t[7] = {
  INTSXP, REALSXP, REALSXP, INTSXP, REALSXP, INTSXP, INTSXP
};
static R_NativePrimitiveArgType unit_arcone_R_t[7] = {
  INTSXP, REALSXP, REALSXP, INTSXP, REALSXP, REALSXP, REALSXP
};
static R_NativePrimitiveArgType PSC_decomp_R_t[11] = {
  INTSXP,
  REALSXP, REALSXP, REALSXP, 
  INTSXP, INTSXP, REALSXP, REALSXP,
  INTSXP, INTSXP, REALSXP
};

extern void orthant_miwa_R(int *np, double *mu, double *Rho, int *log2Gp,
			   double *val, int *nconep,
			   int *conesonlyp);
extern void unit_arcone_R(const int *npointer, double *mu, double *rho,  
			  int *log2Gp, double *Up, double *Sp,
			  double *val);
extern void PSC_decomp_R(const int *np, 
			 double V[*np][*np], 
			 double At[*np][*np], 
			 const double mu[*np], 
			 int *p, 
			 int *log2G, double *U, double *S,
			 int *conesonly,
			 int *ncone,
			 double *value);

R_CMethodDef cMethods[] = {
  {"orthant_miwa_R", (DL_FUNC) &orthant_miwa_R, 7, orthant_miwa_R_t},
  {"unit_arcone_R", (DL_FUNC) &unit_arcone_R, 7, unit_arcone_R_t},
  {"PSC_decomp_R", (DL_FUNC) &PSC_decomp_R, 11, PSC_decomp_R_t},
  {NULL, NULL, 0}
};

void R_init_orthants(DllInfo *info) {
  R_registerRoutines(info, cMethods, NULL, NULL, NULL);
  cftp = R_GetCCallable("fftplus", "cft");
}
#endif
